/*
 * GXMame
 *
 * 2002, Stphane Pontier <shadow_walker@users.sourceforge.net>
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <stdio.h>
#include <string.h>

#include <gdk/gdkkeysyms.h>
#include <gtk/gtk.h>

#include "callbacks.h"
#include "gxmame.h"
#include "gui.h"
#include "audit.h"
#include "interface.h"
#include "support.h"
#include "properties.h"
#include "../pixmaps-builtin/general.xpm"
#include "../pixmaps-builtin/checkmark.xpm"

#include <stdio.h>
#include <stdlib.h>

#define BUFFER_SIZE 1000

GtkWidget *details_audit_result;
GtkWidget *sample_check_result;
GtkWidget *rom_check_result;
GtkWidget *notebook1;
GtkWidget *manu_status_value;
gboolean game_checked = FALSE;


void
on_properties_ok_button_clicked        (GtkButton       *button,
                                        gpointer         user_data);
void
on_properties_cancel_button_clicked    (GtkButton       *button,
                                        gpointer         user_data);
void
on_properties_apply_button_clicked     (GtkButton       *button,
                                        gpointer         user_data);

void
exit_properties_window		       (GtkWidget      *window,
                                        gpointer         user_data
		                        );
void
on_notebook1_switch_page               (GtkNotebook     *notebook,
                                        GtkNotebookPage *page,
                                        gint             page_num,
                                        gpointer         user_data);

GtkWidget*
create_properties_windows (void)
{
	GtkWidget *properties_windows;
	GtkWidget *vbox9;
	GtkWidget *table7;
	GtkWidget *hseparator7;
	GtkWidget *hseparator8;
	GtkWidget *hseparator9;
	GtkWidget *hseparator10;
	GtkWidget *label20;
	GtkWidget *label19;
	GtkWidget *cpu_value;
	GtkWidget *sound_value;
	GtkWidget *screen_colors_clone_value;
	GtkWidget *label22;
	GtkWidget *label21;
	GtkWidget *label31;
	GtkWidget *label23;
	GtkWidget *label26;
	GtkWidget *label25;
	GtkWidget *title_rom_value;
	GtkWidget *general_panel;
	GtkWidget *audit_panel;
	GtkWidget *hbox3;
	/*audit panel */
	GtkWidget *table8;
	GtkWidget *frame3;
	GtkWidget *scrolledwindow7;
	GtkWidget *hbox4;
	GtkWidget *pixmap2;
	GtkWidget *title_romname;
	GtkWidget *hseparator11;
	GtkWidget *label33;
	GtkWidget *label35;
  
	GtkWidget *properties_ok_button;
	GtkWidget *properties_cancel_button;
	guint properties_apply_button_key;
	GtkWidget *properties_apply_button;
	GtkAccelGroup *accel_group;
	GtkWidget *pixmap1;
	GdkPixmap *gdk_pixmap1;
	GdkBitmap *mask1;
	GdkColor  transparent;
	
	gchar title[BUFFER_SIZE];
	gchar *value1, *value2, *value3, *value4;
	GList *listpointer;
	gboolean game_found=FALSE;
	RomEntry *tmprom = NULL;
	game_checked = FALSE;

	accel_group = gtk_accel_group_new ();

	properties_windows = gtk_window_new (GTK_WINDOW_DIALOG);
	gtk_object_set_data (GTK_OBJECT (properties_windows), "properties_windows", properties_windows);
	gtk_widget_set_usize (properties_windows, 355, 425);
	g_snprintf(title,BUFFER_SIZE,_("%s Properties"),gui_prefs.DefaultGame);
	gtk_window_set_title (GTK_WINDOW (properties_windows), title);
	gtk_window_set_position (GTK_WINDOW (properties_windows), GTK_WIN_POS_MOUSE);
	gtk_window_set_transient_for(GTK_WINDOW(properties_windows),GTK_WINDOW(MainWindow));
	gtk_window_set_modal(GTK_WINDOW(properties_windows),TRUE);
			
	vbox9 = gtk_vbox_new (FALSE, 0);
	gtk_widget_ref (vbox9);
	gtk_object_set_data_full (GTK_OBJECT (properties_windows), "vbox9", vbox9,
				  (GtkDestroyNotify) gtk_widget_unref);
	gtk_widget_show (vbox9);
	gtk_container_add (GTK_CONTAINER (properties_windows), vbox9);

	notebook1 = gtk_notebook_new ();
	gtk_widget_ref (notebook1);
	gtk_object_set_data_full (GTK_OBJECT (properties_windows), "notebook1", notebook1,
				  (GtkDestroyNotify) gtk_widget_unref);
	gtk_widget_show (notebook1);
	gtk_box_pack_start (GTK_BOX (vbox9), notebook1, TRUE, TRUE, 0);
	gtk_container_set_border_width (GTK_CONTAINER (notebook1), 8);

	table7 = gtk_table_new (9, 3, FALSE);
	gtk_widget_ref (table7);
	gtk_object_set_data_full (GTK_OBJECT (properties_windows), "table7", table7,
				  (GtkDestroyNotify) gtk_widget_unref);
	gtk_widget_show (table7);
	gtk_container_add (GTK_CONTAINER (notebook1), table7);
	gtk_container_set_border_width (GTK_CONTAINER (table7), 20);

	gdk_pixmap1 = gdk_pixmap_create_from_xpm_d(
				MainWindow->window,
				&mask1,
				&transparent,
				general_xpm);
	pixmap1 = gtk_pixmap_new (gdk_pixmap1,mask1);
	gtk_widget_ref (pixmap1);
	gdk_pixmap_unref(gdk_pixmap1);
	gdk_pixmap_unref(mask1);
	gtk_object_set_data_full (GTK_OBJECT (properties_windows), "pixmap1", pixmap1,
				  (GtkDestroyNotify) gtk_widget_unref);
	gtk_widget_show (pixmap1);
	gtk_table_attach (GTK_TABLE (table7), pixmap1, 0, 1, 0, 1,
	  	    (GtkAttachOptions) (GTK_FILL),
	  	    (GtkAttachOptions) (GTK_FILL), 0, 0);
	gtk_misc_set_alignment (GTK_MISC (pixmap1), 0, 0.5);

	/*title_rom_value = gtk_label_new (_("Title\n\"romname\""));*/
	g_snprintf(title,BUFFER_SIZE,"%s\n\"%s\"",gui_prefs.DefaultGame,(gui_prefs.DefaultGame_p)->romname);
	title_rom_value = gtk_label_new (title);
	gtk_widget_ref (title_rom_value);
	gtk_object_set_data_full (GTK_OBJECT (properties_windows), "title_rom_value", title_rom_value,
				  (GtkDestroyNotify) gtk_widget_unref);
	gtk_widget_show (title_rom_value);
	gtk_table_attach (GTK_TABLE (table7), title_rom_value, 1, 3, 0, 1,
			  (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
			  (GtkAttachOptions) (GTK_EXPAND), 0, 3);
	gtk_label_set_justify (GTK_LABEL (title_rom_value), GTK_JUSTIFY_LEFT);
	gtk_label_set_line_wrap (GTK_LABEL (title_rom_value), TRUE);
	gtk_misc_set_alignment (GTK_MISC (title_rom_value), 0, 0.5);

	hseparator7 = gtk_hseparator_new ();
	gtk_widget_ref (hseparator7);
	gtk_object_set_data_full (GTK_OBJECT (properties_windows), "hseparator7", hseparator7,
				  (GtkDestroyNotify) gtk_widget_unref);
	gtk_widget_show (hseparator7);
	gtk_table_attach (GTK_TABLE (table7), hseparator7, 0, 3, 1, 2,
			  (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
			  (GtkAttachOptions) (GTK_FILL), 0, 0);

	label19 = gtk_label_new (_("Manufacturer:\nStatus:"));
	gtk_widget_ref (label19);
	gtk_object_set_data_full (GTK_OBJECT (properties_windows), "label19", label19,
				  (GtkDestroyNotify) gtk_widget_unref);
	gtk_widget_show (label19);
	gtk_table_attach (GTK_TABLE (table7), label19, 0, 1, 2, 3,
			  (GtkAttachOptions) (GTK_SHRINK | GTK_FILL),
			  (GtkAttachOptions) (GTK_EXPAND | GTK_FILL), 0, 0);
	gtk_label_set_justify (GTK_LABEL (label19), GTK_JUSTIFY_LEFT);
	gtk_misc_set_alignment (GTK_MISC (label19), 0, 0.5);

	label23 = gtk_label_new ("       \n");
	gtk_widget_ref (label23);
	gtk_object_set_data_full (GTK_OBJECT (properties_windows), "label23", label23,
	                          (GtkDestroyNotify) gtk_widget_unref);
	gtk_widget_show (label23);
	gtk_table_attach (GTK_TABLE (table7), label23, 1, 2, 2, 3,
	                  (GtkAttachOptions) (GTK_SHRINK),
	                  (GtkAttachOptions) (GTK_FILL), 0, 0);
	gtk_misc_set_alignment (GTK_MISC (label23), 0, 0.5);

	/*manu_status_value = gtk_label_new (_("Year Manufacturer value\nStatus value"));*/
	if ((gui_prefs.DefaultGame_p)->has_roms == 2)
		g_snprintf(title,BUFFER_SIZE,_("%s %s\nUNKNOWN"),(gui_prefs.DefaultGame_p)->year,(gui_prefs.DefaultGame_p)->manu);
	else if ((gui_prefs.DefaultGame_p)->has_roms == 0)
		g_snprintf(title,BUFFER_SIZE,_("%s %s\nROMs missing"),(gui_prefs.DefaultGame_p)->year,(gui_prefs.DefaultGame_p)->manu);
	else if (!(gui_prefs.DefaultGame_p)->status)
		g_snprintf(title,BUFFER_SIZE,_("%s %s\nNot working"),(gui_prefs.DefaultGame_p)->year,(gui_prefs.DefaultGame_p)->manu);
	else
		g_snprintf(title,BUFFER_SIZE,_("%s %s\nWorking"),(gui_prefs.DefaultGame_p)->year,(gui_prefs.DefaultGame_p)->manu);
	manu_status_value = gtk_label_new (title);
	gtk_widget_ref (manu_status_value);
	gtk_object_set_data_full (GTK_OBJECT (properties_windows), "manu_status_value", manu_status_value,
				  (GtkDestroyNotify) gtk_widget_unref);
	gtk_widget_show (manu_status_value);
	gtk_table_attach (GTK_TABLE (table7), manu_status_value, 2, 3, 2, 3,
			  (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
			  (GtkAttachOptions) (GTK_FILL), 0, 0);
	gtk_label_set_justify (GTK_LABEL (manu_status_value), GTK_JUSTIFY_LEFT);
	gtk_misc_set_alignment (GTK_MISC (manu_status_value), 0, 0.5);

	hseparator8 = gtk_hseparator_new ();
	gtk_widget_ref (hseparator8);
	gtk_object_set_data_full (GTK_OBJECT (properties_windows), "hseparator8", hseparator8,
				  (GtkDestroyNotify) gtk_widget_unref);
	gtk_widget_show (hseparator8);
	gtk_table_attach (GTK_TABLE (table7), hseparator8, 0, 3, 3, 4,
			  (GtkAttachOptions) (GTK_FILL),
			  (GtkAttachOptions) (GTK_FILL), 0, 0);

	label20 = gtk_label_new (_("CPU:"));
	gtk_widget_ref (label20);
	gtk_object_set_data_full (GTK_OBJECT (properties_windows), "label20", label20,
				  (GtkDestroyNotify) gtk_widget_unref);
	gtk_widget_show (label20);
	gtk_table_attach (GTK_TABLE (table7), label20, 0, 1, 4, 5,
			  (GtkAttachOptions) (GTK_SHRINK | GTK_FILL),
			  (GtkAttachOptions) (GTK_EXPAND | GTK_FILL), 0, 3);
	gtk_label_set_justify (GTK_LABEL (label20), GTK_JUSTIFY_LEFT);
	gtk_misc_set_alignment (GTK_MISC (label20), 0, 0);

	label31 = gtk_label_new ("       \n\n\n");
	gtk_widget_ref (label31);
	gtk_object_set_data_full (GTK_OBJECT (properties_windows), "label31", label31,
				  (GtkDestroyNotify) gtk_widget_unref);
	gtk_widget_show (label31);
	gtk_table_attach (GTK_TABLE (table7), label31, 1, 2, 4, 5,
			  (GtkAttachOptions) (GTK_FILL),
			  (GtkAttachOptions) (GTK_FILL), 0, 3);
	gtk_misc_set_alignment (GTK_MISC (label31), 0, 0.5);


	if (strcmp((gui_prefs.DefaultGame_p)->cpu1,"-"))
	{
		value1 = g_strdup_printf("%s %f Mhz%s",(gui_prefs.DefaultGame_p)->cpu1,(gui_prefs.DefaultGame_p)->cpu1_clock/1000000.0,(gui_prefs.DefaultGame_p)->cpu1_sound_flag?_(" (sound)"):" ");
	}
	else
		value1 = g_strdup_printf(" ");
	if (strcmp((gui_prefs.DefaultGame_p)->cpu2,"-"))
	{
		value2 = g_strdup_printf("%s %f Mhz%s",(gui_prefs.DefaultGame_p)->cpu2,(gui_prefs.DefaultGame_p)->cpu2_clock/1000000.0,(gui_prefs.DefaultGame_p)->cpu2_sound_flag?_(" (sound)"):" ");
	}
	else
		value2 = g_strdup_printf(" ");
	if (strcmp((gui_prefs.DefaultGame_p)->cpu3,"-"))
	{
		value3 = g_strdup_printf("%s %f Mhz%s",(gui_prefs.DefaultGame_p)->cpu3,(gui_prefs.DefaultGame_p)->cpu3_clock/1000000.0,(gui_prefs.DefaultGame_p)->cpu3_sound_flag?_(" (sound)"):" ");
	}
	else
		value3 = g_strdup_printf(" ");
	if (strcmp((gui_prefs.DefaultGame_p)->cpu4,"-"))
	{
		value4 = g_strdup_printf("%s %f Mhz%s",(gui_prefs.DefaultGame_p)->cpu4,(gui_prefs.DefaultGame_p)->cpu4_clock/1000000.0,(gui_prefs.DefaultGame_p)->cpu4_sound_flag?_(" (sound)"):" ");
	}
	else
		value4 = g_strdup_printf(" ");
	g_snprintf(title,BUFFER_SIZE,"%s\n%s\n%s\n%s",value1,value2,value3,value4);
//	cpu_value = gtk_label_new (_("CPU value"));
	cpu_value = gtk_label_new (title);
	g_free(value1);
	g_free(value2);
	g_free(value3);
	g_free(value4);
	gtk_widget_ref (cpu_value);
	gtk_object_set_data_full (GTK_OBJECT (properties_windows), "cpu_value", cpu_value,
				  (GtkDestroyNotify) gtk_widget_unref);
	gtk_widget_show (cpu_value);
	gtk_table_attach (GTK_TABLE (table7), cpu_value, 2, 3, 4, 5,
			  (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
			  (GtkAttachOptions) (GTK_FILL), 0, 3);
	gtk_label_set_justify (GTK_LABEL (cpu_value), GTK_JUSTIFY_LEFT);
	gtk_misc_set_alignment (GTK_MISC (cpu_value), 0, 0);

	hseparator9 = gtk_hseparator_new ();
	gtk_widget_ref (hseparator9);
	gtk_object_set_data_full (GTK_OBJECT (properties_windows), "hseparator9", hseparator9,
				  (GtkDestroyNotify) gtk_widget_unref);
	gtk_widget_show (hseparator9);
	gtk_table_attach (GTK_TABLE (table7), hseparator9, 0, 3, 5, 6,
			  (GtkAttachOptions) (GTK_FILL),
			  (GtkAttachOptions) (GTK_FILL), 0, 0);

	label21 = gtk_label_new (_("Sound:"));
	gtk_widget_ref (label21);
	gtk_object_set_data_full (GTK_OBJECT (properties_windows), "label21", label21,
				  (GtkDestroyNotify) gtk_widget_unref);
	gtk_widget_show (label21);
	gtk_table_attach (GTK_TABLE (table7), label21, 0, 1, 6, 7,
			  (GtkAttachOptions) (GTK_SHRINK | GTK_FILL),
			  (GtkAttachOptions) (GTK_EXPAND | GTK_FILL), 0, 3);
	gtk_label_set_justify (GTK_LABEL (label21), GTK_JUSTIFY_LEFT);
	gtk_misc_set_alignment (GTK_MISC (label21), 0, 0);

	label25 = gtk_label_new ("\n\n\n");
	gtk_widget_ref (label25);
	gtk_object_set_data_full (GTK_OBJECT (properties_windows), "label25", label25,
				  (GtkDestroyNotify) gtk_widget_unref);
	gtk_widget_show (label25);
	gtk_table_attach (GTK_TABLE (table7), label25, 1, 2, 6, 7,
			  (GtkAttachOptions) (GTK_FILL),
			  (GtkAttachOptions) (GTK_FILL), 0, 3);
	gtk_misc_set_alignment (GTK_MISC (label25), 0, 0.5);

	if (strcmp((gui_prefs.DefaultGame_p)->sound1,"-"))
	{
		if ((gui_prefs.DefaultGame_p)->sound1_clock==0)
			value1 = g_strdup_printf("%s",(gui_prefs.DefaultGame_p)->sound1);
		else
			value1 = g_strdup_printf("%s %f Mhz",(gui_prefs.DefaultGame_p)->sound1,(gui_prefs.DefaultGame_p)->sound1_clock/1000000.0);
	}
	else
		value1 = g_strdup_printf(" ");
	if (strcmp((gui_prefs.DefaultGame_p)->sound2,"-"))
	{
		if ((gui_prefs.DefaultGame_p)->sound2_clock==0)
			value2 = g_strdup_printf("%s",(gui_prefs.DefaultGame_p)->sound2);
		else
			value2 = g_strdup_printf("%s %f Mhz",(gui_prefs.DefaultGame_p)->sound2,(gui_prefs.DefaultGame_p)->sound2_clock/1000000.0);
	}
	else
		value2 = g_strdup_printf(" ");
	if (strcmp((gui_prefs.DefaultGame_p)->sound3,"-"))
	{
		if ((gui_prefs.DefaultGame_p)->sound3_clock==0)
			value3 = g_strdup_printf("%s",(gui_prefs.DefaultGame_p)->sound3);
		else
			value3 = g_strdup_printf("%s %f Mhz",(gui_prefs.DefaultGame_p)->sound3,(gui_prefs.DefaultGame_p)->sound3_clock/1000000.0);
	}
	else
		value3 = g_strdup_printf(" ");
	if (strcmp((gui_prefs.DefaultGame_p)->sound4,"-"))
	{
		if ((gui_prefs.DefaultGame_p)->sound4_clock==0)
			value4 = g_strdup_printf("%s",(gui_prefs.DefaultGame_p)->sound4);
		else
			value4 = g_strdup_printf("%s %f Mhz",(gui_prefs.DefaultGame_p)->sound4,(gui_prefs.DefaultGame_p)->sound4_clock/1000000.0);
	}
	else
		value4 = g_strdup_printf(" ");
	g_snprintf(title,BUFFER_SIZE,"%s\n%s\n%s\n%s",value1,value2,value3,value4);
//	sound_value = gtk_label_new (_("Sound value"));
	sound_value = gtk_label_new (title);
	g_free(value1);
	g_free(value2);
	g_free(value3);
	g_free(value4);
	gtk_widget_ref (sound_value);
	gtk_object_set_data_full (GTK_OBJECT (properties_windows), "sound_value", sound_value,
				  (GtkDestroyNotify) gtk_widget_unref);
	gtk_widget_show (sound_value);
	gtk_table_attach (GTK_TABLE (table7), sound_value, 2, 3, 6, 7,
			  (GtkAttachOptions) (GTK_FILL),
			  (GtkAttachOptions) (GTK_FILL), 0, 3);
	gtk_label_set_justify (GTK_LABEL (sound_value), GTK_JUSTIFY_LEFT);
	gtk_misc_set_alignment (GTK_MISC (sound_value), 0, 0);

	hseparator10 = gtk_hseparator_new ();
	gtk_widget_ref (hseparator10);
	gtk_object_set_data_full (GTK_OBJECT (properties_windows), "hseparator10", hseparator10,
				  (GtkDestroyNotify) gtk_widget_unref);
	gtk_widget_show (hseparator10);
	gtk_table_attach (GTK_TABLE (table7), hseparator10, 0, 3, 7, 8,
			  (GtkAttachOptions) (GTK_FILL),
			  (GtkAttachOptions) (GTK_FILL), 0, 0);

	if (strcmp((gui_prefs.DefaultGame_p)->cloneof,"-"))
		label22 = gtk_label_new (_("Screen:\nColors:\nClone of:"));
	else
		label22 = gtk_label_new (_("Screen:\nColors:\n"));
	gtk_widget_ref (label22);
	gtk_object_set_data_full (GTK_OBJECT (properties_windows), "label22", label22,
				  (GtkDestroyNotify) gtk_widget_unref);
	gtk_widget_show (label22);
	gtk_table_attach (GTK_TABLE (table7), label22, 0, 1, 8, 9,
			  (GtkAttachOptions) (GTK_SHRINK | GTK_FILL),
			  (GtkAttachOptions) (GTK_EXPAND | GTK_FILL), 0, 3);
	gtk_label_set_justify (GTK_LABEL (label22), GTK_JUSTIFY_LEFT);
	gtk_misc_set_alignment (GTK_MISC (label22), 0, 0);

	label26 = gtk_label_new ("\n\n");
	gtk_widget_ref (label26);
	gtk_object_set_data_full (GTK_OBJECT (properties_windows), "label26", label26,
				  (GtkDestroyNotify) gtk_widget_unref);
	gtk_widget_show (label26);
	gtk_table_attach (GTK_TABLE (table7), label26, 1, 2, 8, 9,
			  (GtkAttachOptions) (GTK_FILL),
			  (GtkAttachOptions) (GTK_FILL), 0, 3);
	gtk_misc_set_alignment (GTK_MISC (label26), 0, 0.5);

	/* doesn't display resolution if this is a vector game */
	if (!(gui_prefs.DefaultGame_p)->vector)
		value1 = g_strdup_printf("%i x %i ",(gui_prefs.DefaultGame_p)->screen_x,(gui_prefs.DefaultGame_p)->screen_y);
	else
		value1 = g_strdup_printf(" ");
	
	/* find the clone name if there is a clone */
	if (strcmp((gui_prefs.DefaultGame_p)->cloneof,"-"))
	{
		for(listpointer = g_list_first(roms), game_found = FALSE;
				(listpointer != NULL);
				listpointer = g_list_next(listpointer))
		{
			tmprom = (RomEntry *) listpointer->data;
			if (!strcmp(tmprom->romname,(gui_prefs.DefaultGame_p)->cloneof))
			{
				game_found = TRUE;
				break;
			}
		}
		if (game_found)
		{
			if (tmprom->the_trailer && gui_prefs.ModifyThe)
				value2 = g_strstrip(g_strdup_printf("%s, The %s - \"%s\"",tmprom->gamename,tmprom->gamenameext,(gui_prefs.DefaultGame_p)->cloneof));
			else if (tmprom->the_trailer && !gui_prefs.ModifyThe)
				value2 = g_strstrip(g_strdup_printf("The %s %s - \"%s\"",tmprom->gamename,tmprom->gamenameext,(gui_prefs.DefaultGame_p)->cloneof));
			else
				value2 = g_strstrip(g_strdup_printf("%s %s - \"%s\"",tmprom->gamename,tmprom->gamenameext,(gui_prefs.DefaultGame_p)->cloneof));
		}
		else
			value2 = g_strdup_printf(" - \"%s\"",(gui_prefs.DefaultGame_p)->cloneof);
	}
	else
		value2 = g_strdup_printf(" ");
	
	g_snprintf(title,BUFFER_SIZE,"%s(%s) %.2f Hz\n%i colors\n%s",
			value1,
			(gui_prefs.DefaultGame_p)->horizontal?"horz":"vert",
			(gui_prefs.DefaultGame_p)->screen_freq,
			(gui_prefs.DefaultGame_p)->colors,
			value2);
//	screen_colors_clone_value = gtk_label_new (_("Screen value\nColor Value\nClone of value"));
	g_free(value1);
	g_free(value2);
	screen_colors_clone_value = gtk_label_new (title);
	gtk_widget_ref (screen_colors_clone_value);
	gtk_object_set_data_full (GTK_OBJECT (properties_windows), "screen_colors_clone_value", screen_colors_clone_value,
				  (GtkDestroyNotify) gtk_widget_unref);
	gtk_widget_show (screen_colors_clone_value);
	gtk_table_attach (GTK_TABLE (table7), screen_colors_clone_value, 2, 3, 8, 9,
			  (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
			  (GtkAttachOptions) (GTK_FILL), 0, 3);
	gtk_label_set_justify (GTK_LABEL (screen_colors_clone_value), GTK_JUSTIFY_LEFT);
	gtk_label_set_line_wrap (GTK_LABEL (screen_colors_clone_value), TRUE);
	gtk_misc_set_alignment (GTK_MISC (screen_colors_clone_value), 0, 0);


	/*Audit panel*/
	table8 = gtk_table_new (5, 2, FALSE);
	gtk_widget_ref (table8);
	gtk_object_set_data_full (GTK_OBJECT (properties_windows), "table8", table8,
				  (GtkDestroyNotify) gtk_widget_unref);
	gtk_widget_show (table8);
	gtk_container_add (GTK_CONTAINER (notebook1), table8);
	gtk_container_set_border_width (GTK_CONTAINER (table8), 10);
	gtk_table_set_row_spacings (GTK_TABLE (table8), 15);

	frame3 = gtk_frame_new (_("Details"));
	gtk_widget_ref (frame3);
	gtk_object_set_data_full (GTK_OBJECT (properties_windows), "frame3", frame3,
				  (GtkDestroyNotify) gtk_widget_unref);
	gtk_widget_show (frame3);
	gtk_table_attach (GTK_TABLE (table8), frame3, 0, 2, 4, 5,
			  (GtkAttachOptions) (GTK_FILL),
			  (GtkAttachOptions) (GTK_EXPAND | GTK_FILL), 0, 0);

	scrolledwindow7 = gtk_scrolled_window_new (NULL, NULL);
	gtk_widget_ref (scrolledwindow7);
	gtk_object_set_data_full (GTK_OBJECT (properties_windows), "scrolledwindow7", scrolledwindow7,
				  (GtkDestroyNotify) gtk_widget_unref);
	gtk_widget_show (scrolledwindow7);
	gtk_container_add (GTK_CONTAINER (frame3), scrolledwindow7);
	gtk_container_set_border_width (GTK_CONTAINER (scrolledwindow7), 10);
	gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow7), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);

	details_audit_result = gtk_text_new (NULL, NULL);
	gtk_widget_ref (details_audit_result);
	gtk_object_set_data_full (GTK_OBJECT (properties_windows), "details_audit_result", details_audit_result,
				  (GtkDestroyNotify) gtk_widget_unref);
	gtk_widget_show (details_audit_result);
//	gtk_text_set_line_wrap(GTK_TEXT(details_audit_result),FALSE);
	gtk_container_add (GTK_CONTAINER (scrolledwindow7), details_audit_result);

	hbox4 = gtk_hbox_new (FALSE, 10);
	gtk_widget_ref (hbox4);
	gtk_object_set_data_full (GTK_OBJECT (properties_windows), "hbox4", hbox4,
				  (GtkDestroyNotify) gtk_widget_unref);
	gtk_widget_show (hbox4);
	gtk_table_attach (GTK_TABLE (table8), hbox4, 0, 2, 0, 1,
			  (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
			  (GtkAttachOptions) (0), 0, 0);

	gdk_pixmap1 = gdk_pixmap_create_from_xpm_d(
				MainWindow->window,
				&mask1,
				&transparent,
				checkmark_xpm);
	pixmap2 = gtk_pixmap_new (gdk_pixmap1,mask1);
	gtk_widget_ref (pixmap2);
	gdk_pixmap_unref(gdk_pixmap1);
	gdk_pixmap_unref(mask1);
	gtk_object_set_data_full (GTK_OBJECT (properties_windows), "pixmap2", pixmap2,
				  (GtkDestroyNotify) gtk_widget_unref);
	gtk_widget_show (pixmap2);
	gtk_box_pack_start (GTK_BOX (hbox4), pixmap2, FALSE, FALSE, 0);
	gtk_misc_set_padding (GTK_MISC (pixmap2), 10, 0);

	g_snprintf(title,BUFFER_SIZE,"%s\n\"%s\"",gui_prefs.DefaultGame,(gui_prefs.DefaultGame_p)->romname);
	title_romname = gtk_label_new (title);
	gtk_widget_ref (title_romname);
	gtk_object_set_data_full (GTK_OBJECT (properties_windows), "title_romname", title_romname,
				  (GtkDestroyNotify) gtk_widget_unref);
	gtk_widget_show (title_romname);
	gtk_box_pack_start (GTK_BOX (hbox4), title_romname, FALSE, FALSE, 0);
	gtk_label_set_justify (GTK_LABEL (title_romname), GTK_JUSTIFY_LEFT);
	gtk_label_set_line_wrap (GTK_LABEL (title_romname), TRUE);
	gtk_misc_set_padding (GTK_MISC (title_romname), 0, 0);

	sample_check_result = gtk_label_new (_("Checking..."));
	gtk_widget_ref (sample_check_result);
	gtk_object_set_data_full (GTK_OBJECT (properties_windows), "sample_check_result", sample_check_result,
				  (GtkDestroyNotify) gtk_widget_unref);
	gtk_widget_show (sample_check_result);
	gtk_table_attach (GTK_TABLE (table8), sample_check_result, 1, 2, 3, 4,
			  (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
			  (GtkAttachOptions) (0), 0, 0);
	gtk_misc_set_alignment (GTK_MISC (sample_check_result), 0, 0.5);
	gtk_misc_set_padding (GTK_MISC (sample_check_result), 30, 0);

	rom_check_result = gtk_label_new (_("Checking..."));
	gtk_widget_ref (rom_check_result);
	gtk_object_set_data_full (GTK_OBJECT (properties_windows), "rom_check_result", rom_check_result,
				  (GtkDestroyNotify) gtk_widget_unref);
	gtk_widget_show (rom_check_result);
	gtk_table_attach (GTK_TABLE (table8), rom_check_result, 1, 2, 2, 3,
			  (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
			  (GtkAttachOptions) (0), 0, 0);
	gtk_misc_set_alignment (GTK_MISC (rom_check_result), 0, 0.5);
	gtk_misc_set_padding (GTK_MISC (rom_check_result), 30, 0);

	hseparator11 = gtk_hseparator_new ();
	gtk_widget_ref (hseparator11);
	gtk_object_set_data_full (GTK_OBJECT (properties_windows), "hseparator11", hseparator11,
				  (GtkDestroyNotify) gtk_widget_unref);
	gtk_widget_show (hseparator11);
	gtk_table_attach (GTK_TABLE (table8), hseparator11, 0, 2, 1, 2,
			  (GtkAttachOptions) (GTK_FILL),
			  (GtkAttachOptions) (0), 10, 0);

	label33 = gtk_label_new (_("ROM check:"));
	gtk_widget_ref (label33);
	gtk_object_set_data_full (GTK_OBJECT (properties_windows), "label33", label33,
				  (GtkDestroyNotify) gtk_widget_unref);
	gtk_widget_show (label33);
	gtk_table_attach (GTK_TABLE (table8), label33, 0, 1, 2, 3,
			  (GtkAttachOptions) (GTK_FILL),
			  (GtkAttachOptions) (0), 0, 0);
	gtk_misc_set_alignment (GTK_MISC (label33), 0, 0.5);
	gtk_misc_set_padding (GTK_MISC (label33), 10, 0);

	label35 = gtk_label_new (_("Sample check:"));
	gtk_widget_ref (label35);
	gtk_object_set_data_full (GTK_OBJECT (properties_windows), "label35", label35,
				  (GtkDestroyNotify) gtk_widget_unref);
	gtk_widget_show (label35);
	gtk_table_attach (GTK_TABLE (table8), label35, 0, 1, 3, 4,
			  (GtkAttachOptions) (GTK_FILL),
			  (GtkAttachOptions) (0), 0, 0);
	gtk_misc_set_alignment (GTK_MISC (label35), 0, 0.5);
	gtk_misc_set_padding (GTK_MISC (label35), 10, 0);

	
	
	

	general_panel = gtk_label_new (_("General"));
	gtk_widget_ref (general_panel);
	gtk_object_set_data_full (GTK_OBJECT (properties_windows), "general_panel", general_panel,
				  (GtkDestroyNotify) gtk_widget_unref);
	gtk_widget_show (general_panel);
	gtk_notebook_set_tab_label (GTK_NOTEBOOK (notebook1), gtk_notebook_get_nth_page (GTK_NOTEBOOK (notebook1), 0), general_panel);

	audit_panel = gtk_label_new (_("Audit"));
	gtk_widget_ref (audit_panel);
	gtk_object_set_data_full (GTK_OBJECT (properties_windows), "audit_panel", audit_panel,
				  (GtkDestroyNotify) gtk_widget_unref);
	gtk_widget_show (audit_panel);
	gtk_notebook_set_tab_label (GTK_NOTEBOOK (notebook1), gtk_notebook_get_nth_page (GTK_NOTEBOOK (notebook1), 1), audit_panel);

	hbox3 = gtk_hbox_new (FALSE, 0);
	gtk_widget_ref (hbox3);
	gtk_object_set_data_full (GTK_OBJECT (properties_windows), "hbox3", hbox3,
				  (GtkDestroyNotify) gtk_widget_unref);
	gtk_widget_show (hbox3);
	gtk_box_pack_start (GTK_BOX (vbox9), hbox3, FALSE, TRUE, 0);
	gtk_container_set_border_width (GTK_CONTAINER (hbox3), 5);

	properties_apply_button = gtk_button_new_with_label ("");
	properties_apply_button_key = gtk_label_parse_uline (GTK_LABEL (GTK_BIN (properties_apply_button)->child),
					 _("_Apply"));
	gtk_widget_add_accelerator (properties_apply_button, "clicked", accel_group,
				    properties_apply_button_key, GDK_MOD1_MASK, (GtkAccelFlags) 0);
	gtk_widget_ref (properties_apply_button);
	gtk_object_set_data_full (GTK_OBJECT (properties_windows), "properties_apply_button", properties_apply_button,
				  (GtkDestroyNotify) gtk_widget_unref);
	gtk_widget_show (properties_apply_button);
	gtk_widget_set_sensitive (properties_apply_button,FALSE);
	gtk_box_pack_end (GTK_BOX (hbox3), properties_apply_button, FALSE, TRUE, 3);
	gtk_widget_set_usize (properties_apply_button, 50, -2);

	properties_cancel_button = gtk_button_new_with_label (_("Cancel"));
	gtk_widget_ref (properties_cancel_button);
	gtk_object_set_data_full (GTK_OBJECT (properties_windows), "properties_cancel_button", properties_cancel_button,
				  (GtkDestroyNotify) gtk_widget_unref);
	gtk_widget_show (properties_cancel_button);
	gtk_box_pack_end (GTK_BOX (hbox3), properties_cancel_button, FALSE, TRUE, 3);
	gtk_widget_set_usize (properties_cancel_button, 50, -2);

	properties_ok_button = gtk_button_new_with_label (_("OK"));
	gtk_widget_ref (properties_ok_button);
	gtk_object_set_data_full (GTK_OBJECT (properties_windows), "properties_ok_button", properties_ok_button,
				  (GtkDestroyNotify) gtk_widget_unref);
	gtk_widget_show (properties_ok_button);
	gtk_box_pack_end (GTK_BOX (hbox3), properties_ok_button, FALSE, TRUE, 3);
	gtk_widget_set_usize (properties_ok_button, 50, -2);

	gtk_signal_connect_after (GTK_OBJECT (notebook1), "switch_page",
			    GTK_SIGNAL_FUNC (on_notebook1_switch_page),
			    NULL);
	/*temp, change as soon as preferences are implemented */
	gtk_signal_connect_object (GTK_OBJECT (properties_ok_button), "clicked",
			           GTK_SIGNAL_FUNC (exit_properties_window),
			           GTK_OBJECT (properties_windows));
	gtk_signal_connect_object (GTK_OBJECT (properties_cancel_button), "clicked",
			           GTK_SIGNAL_FUNC (exit_properties_window),
			           GTK_OBJECT (properties_windows));
	gtk_signal_connect (GTK_OBJECT (properties_apply_button), "clicked",
			    GTK_SIGNAL_FUNC (on_properties_apply_button_clicked),
			    NULL);
	gtk_signal_connect_object (GTK_OBJECT (properties_windows), "delete-event",
			           GTK_SIGNAL_FUNC (exit_properties_window),
			           GTK_OBJECT (properties_windows));

	gtk_window_add_accel_group (GTK_WINDOW (properties_windows), accel_group);

	return properties_windows;
}


void
on_properties_ok_button_clicked        (GtkButton       *button,
                                        gpointer         user_data)
{

}

void
on_properties_apply_button_clicked     (GtkButton       *button,
                                        gpointer         user_data)
{

}

void
exit_properties_window		       (GtkWidget      *window,
                                        gpointer         user_data
		                        )
{
	gtk_signal_disconnect_by_func   (GTK_OBJECT(notebook1),
                                         (GtkSignalFunc) on_notebook1_switch_page,
                                         NULL);
	gtk_widget_destroy(window);
}

void
on_notebook1_switch_page               (GtkNotebook     *notebook,
                                        GtkNotebookPage *page,
                                        gint             page_num,
                                        gpointer         user_data)
{
	FILE *xmame_pipe=NULL;
	gchar line[BUFFER_SIZE];
	gchar title[BUFFER_SIZE];
	gchar *command, *p, *name;
	gchar *rompath,*samplepath;
	gchar *rompath_option,*samplepath_option;
	guint status;
	gboolean error_during_check=FALSE;
	
	if (page_num == 1 && !game_checked)
	{
		while (gtk_events_pending()) gtk_main_iteration();
		gxmame_debug("single audit");
		rompath = g_strjoinv(":",gui_prefs.RomPath);
		if (strlen(rompath)>0)
			rompath_option = g_strdup_printf("-rompath %s",rompath);
		else
			rompath_option = g_strdup(" ");
		g_free(rompath);
		command = g_strdup_printf("%s -verifyroms %s %s 2>/dev/null",
				mame_executable,
				rompath_option,
				(gui_prefs.DefaultGame_p)->romname);
		g_free(rompath_option);
		gxmame_debug("running command %s",command);
		xmame_pipe = popen(command, "r");
		/* Loading */
		while (fgets(line, BUFFER_SIZE, xmame_pipe))
		{
			/* jump the last comments */
			if (strlen(line)<=1)
				break;
			/* remove the last \n */
			line[strlen(line) - 1] = 0;
			if (!strncmp(line,"romset",6))
			{
				//p = name = line+8;
				for(p = name = line+7;(*p && (*p != ' '));p++);
				*p='\0';p++;
				if (!strncmp(p,"correct",7))
				{
					g_snprintf(title,10,"Passed");
					status = 1;
				}
				else if (!strncmp(p,"incorrect",9) && error_during_check==TRUE)
				{
					status = 0;
					g_snprintf(title,10,"incorrect");
				} else if (!strncmp(p,"not found",9))
				{
					status = 0;
					g_snprintf(title,10,"Not found");
				}
				else if (!strncmp(p,"best available",14))
				{
					status = 1;
					g_snprintf(title,15,"Best available");
				}
				else
				{
					status = 2;
					g_snprintf(title,10,"UNKNOWN");
				}
				(gui_prefs.DefaultGame_p)->has_roms = status;
				
				gtk_label_set_text(GTK_LABEL(rom_check_result),title);
				/*continue with the GUI */
				error_during_check = FALSE;
				while (gtk_events_pending()) gtk_main_iteration();
			}
			else
			{
				g_snprintf(title,BUFFER_SIZE,"%s\n",line);
				gtk_text_insert (GTK_TEXT (details_audit_result), NULL, NULL, NULL,title, -1);
				error_during_check = TRUE;
				while (gtk_events_pending()) gtk_main_iteration();
			}
			while (gtk_events_pending()) gtk_main_iteration();
		}
		pclose(xmame_pipe);
		g_free(command);
	
		/*Samples mow*/
		if ((gui_prefs.DefaultGame_p)->nb_samples >0)
		{
			samplepath = g_strjoinv(":",gui_prefs.SamplePath);
			if (strlen(samplepath)>0)
				samplepath_option = g_strdup_printf("-samplepath %s",samplepath);
			else
				samplepath_option = g_strdup(" ");
			g_free(samplepath);
			command = g_strdup_printf("%s -verifysamples %s %s 2>/dev/null",
					mame_executable,
					samplepath_option,
					(gui_prefs.DefaultGame_p)->romname);
			g_free(samplepath_option);
			gxmame_debug("running command %s",command);
			xmame_pipe = popen(command, "r");
			/* Loading */
			while (fgets(line, BUFFER_SIZE, xmame_pipe))
			{
				/* jump the last comments */
				if (strlen(line)<=1)
					break;
				/* remove the last \n */
				line[strlen(line) - 1] = 0;
				if (!strncmp(line,"sampleset",9))
				{
					//p = name = line+8;
					for(p = name = line+10;(*p && (*p != ' '));p++);
					*p='\0';p++;
					if (!strncmp(p,"correct",7))
					{
						g_snprintf(title,10,"Passed");
						status = 1;
					}
					else if (!strncmp(p,"incorrect",9) && error_during_check==TRUE)
					{
						g_snprintf(title,10,"Incorrect");
						status = 0;
					} else
					{
						status = 2;
						g_snprintf(title,10,"Not found");
					}
					(gui_prefs.DefaultGame_p)->has_samples = status;
					gtk_label_set_text(GTK_LABEL(sample_check_result),title);

					(gui_prefs.DefaultGame_p)->has_samples = status;
					/*continue with the GUI */
					error_during_check = FALSE;
					while (gtk_events_pending()) gtk_main_iteration();
				}
				else
				{
					g_snprintf(title,BUFFER_SIZE,"%s\n",line);
					gtk_text_insert (GTK_TEXT (details_audit_result), NULL, NULL, NULL,title, -1);
					error_during_check = TRUE;
					while (gtk_events_pending()) gtk_main_iteration();
				}
				while (gtk_events_pending()) gtk_main_iteration();
			}
			pclose(xmame_pipe);
			g_free(command);
		}
		else
		{
			g_snprintf(title,14,"None required");
			gtk_label_set_text(GTK_LABEL(sample_check_result),title);
		}
		game_checked = TRUE;
		if ((gui_prefs.DefaultGame_p)->has_roms == 2)
			g_snprintf(title,BUFFER_SIZE,_("%s %s\nUNKNOWN"),(gui_prefs.DefaultGame_p)->year,(gui_prefs.DefaultGame_p)->manu);
		else if ((gui_prefs.DefaultGame_p)->has_roms == 0)
			g_snprintf(title,BUFFER_SIZE,_("%s %s\nROMs missing"),(gui_prefs.DefaultGame_p)->year,(gui_prefs.DefaultGame_p)->manu);
		else if (!(gui_prefs.DefaultGame_p)->status)
			g_snprintf(title,BUFFER_SIZE,_("%s %s\nNot working"),(gui_prefs.DefaultGame_p)->year,(gui_prefs.DefaultGame_p)->manu);
		else
			g_snprintf(title,BUFFER_SIZE,_("%s %s\nWorking"),(gui_prefs.DefaultGame_p)->year,(gui_prefs.DefaultGame_p)->manu);
		gtk_label_set_text(GTK_LABEL(manu_status_value),title);
		/* Update the Main gui*/
		update_game_in_list((gui_prefs.DefaultGame_p)->position);
	}
}

